////////////////////////////
//  Player Bot + Events  //
//////////////////////////
//Originally by Amade
//Modified By Gothboy77 BLID 14329

//Nodes
$nodelist = "armor bicorn bucket cape chest cophat epaulets epauletsranka epauletsrankb epauletsrankc epauletsrankd femchest flarehelmet headskin helmet knithat larm larmslim lhand lhook lpeg lshoe lski pack pants plume pointyhelmet quiver rarm rarmslim rhand rhook rpeg rshoe rski scouthat septplume shoulderpads skirthip skirttrimleft skirttrimright tank triplume visor";

function isnode(%node)
{
	%words = getWordCount($nodelist);
	for(%i = 0; %i < %words; %i++)
	{
		if(getWord($nodelist, %i) $= %node)
		{
			return true;
		}
	}
	return false;
}

//Event Registry
	registerOutputEvent("FxDTSbrick", "BotFireWeapon", "int 0 30000");
	registerOutputEvent("FxDTSbrick", "BotEditAppearance", "list setNodeColor 0 hideNode 1 unhideNode 2 setDecal 3 setFace 4" TAB "string 70 70" TAB "paintcolor 0" TAB "string 30 30", true);
	registerOutputEvent("Bot", "FireWeapon", "int 0 30000");
	registerOutputEvent("Player", "DoEmote", "list Alarm 0 Confusion 1 Hate 2 Love 3 PainLow 4 PainMid 5 PainHigh 6 Win 7");
	registerOutputEvent("Player", "EditAppearance", "list setNodeColor 0 hideNode 1 unhideNode 2 setDecal 3 setFace 4" TAB "string 70 70" TAB "paintcolor 0" TAB "string 30 30", true);
	registerOutputEvent("Player", "MoveToBrick", "string 50 70", true);
	registerOutputEvent("Player", "PlayAnimation", "list NONE 0 Activate 1 Attack 2 ChargeSpear 3 FlailArms 4 Jump 5 PlantBrick 6 PlayDead 7 RightArmUp 8 LeftArmUp 9 BothArmsUp 10 ShakeHead 11 Sit 12 SpinWeapon 13 Talk 14 ThrowSpear 15" TAB "int 0 4 3");

function Player::MoveToBrick(%this, %brickname, %client)
{
	if(isFunction("FilterVariableString"))
	{
		%brick = %client.processingBrick;
		%brickname = filterVariableString(%brickname, %brick, %client, %client.player);
	}
	%blid = isObject(%mini = %this.client.minigame) ? %mini.owner.bl_id : %this.client.bl_id;
	%bricknameGroup = "BrickGroup_" @ %blid;
	if(isObject(%brickname = %bricknameGroup.NTobject_[%brickname, 0]))
	{
		%offset = "0 0 " @ %brickname.getDatablock().brickSizeZ * 0.1;
		%position = vectorAdd(%brickname.getPosition(), %offset);
		%rotation = getWords(%this.getTransform(), 3, 6);
		%transform = %position SPC %rotation;
		%this.setTransform(%transform);
	}
}

function Player::PlayAnimation(%this, %anim, %slot)
{
	switch(%anim)
	{
		case 0: %this.playThread(%slot, "root");
		case 1: %this.playThread(%slot, "activate");
		case 2: %this.playThread(%slot, "armattack");
		case 3: %this.playThread(%slot, "spearcharge");
		case 4: %this.playThread(%slot, "activate2");
		case 5: %this.playThread(%slot, "jump");
		case 6: %this.playThread(%slot, "plant");
		case 7: %this.playThread(%slot, "death1");
		case 8: %this.playThread(%slot, "armreadyright");
		case 9: %this.playThread(%slot, "armreadyleft");
		case 10: %this.playThread(%slot, "armreadyboth");
		case 11: %this.playThread(%slot, "undo");
		case 12: %this.playThread(%slot, "sit");
		case 13: %this.playThread(%slot, "rotCW");
		case 14: %this.playThread(%slot, "talk");
		case 15: %this.playThread(%slot, "spearthrow");
	}
}

function Player::doEmote(%this, %num)
{
	switch(%num)
	{
		case 0: if($AddOnLoaded__Emote_Alarm)
		{
			%this.emote(alarmprojectile);
		}
		case 1: if($AddOnLoaded__Emote_Confusion)
		{
			%this.emote(wtfimage);
		}
		case 2: if($AddOnLoaded__Emote_Hate)
		{
			%this.emote(hateimage);
		}
		case 3: if($AddOnLoaded__Emote_Love)
		{
			%this.emote(loveimage);
		}
		case 4: %this.emote(painlowimage);
		case 5: %this.emote(painmidimage);
		case 6: %this.emote(painhighimage);
		case 7: %this.emote(winstarprojectile); serverPlay3D(rewardSound, %this.getHackPosition());
	}
}

function FxDTSbrick::BotEditAppearance(%this, %action, %node, %color, %str, %client)
{
	if(isObject(%obj = %this.hBot))
	{
		if(%obj.getClassName() $= "AIplayer")
		{
			%obj.editAppearance(%action, %node, %color, %str, %client);
		}
	}
}

function Player::editAppearance(%this, %action, %node, %color, %str, %client)
{
	if(isFunction("FilterVariableString"))
	{
		%brick = %client.processingBrick;
		%node = filterVariableString(%node, %brick, %client, %client.player);
		%str = filterVariableString(%str, %brick, %client, %client.player);
	}
	%color = getWordCount(%str) == 4 ? %str : getColorIDTable(%color);
	if(isObject(%this))
	{
		if(%this.getDatablock().shapeFile !$= "base/data/shapes/player/m.dts")
		{
			%node = "all";
		}
		%this.appearanceModified = true;
		%node = strlwr(%node);
		%node = strReplace(%node, "foot", "shoe");
		%node = strReplace(%node, "feet", "LShoe RShoe LPeg RPeg");
		%node = strReplace(%node, "legs", "LShoe RShoe LPeg RPeg");
		%node = strReplace(%node, "hands", "LHand RHand LHook RHook");
		%node = strReplace(%node, "arms", "LArm Rarm LArmSlim RArmSlim");
		%node = strReplace(%node, "head", "headskin");
		%node = strReplace(%node, "headskinskin", "headskin");
		if(%action < 3)
		{
			if(%node $= "all")
			{
				switch(%action)
				{
					case 0: %this.setNodeColor("ALL", %color);
					case 1: %this.hideNode("ALL");
					case 2: %this.unhideNode("ALL"); %this.setNodeColor("ALL", %color); %this.setHeadUp(true);
				}
				return;
			}
			for(%i = 0; %i < getWordCount(%node); %i++)
			{
				if(!isnode(getWord(%node, %i)))
				{
					return;
				}
			}
		}
		if(%action == 1 || %action == 2)
		{
			%bool = %action == 2;
			for(%i = 0; %i < getWordCount(%node); %i++)
			{
				switch$(getWord(%node, %i))
				{
					case "armor": %this.setHeadUp(%bool); break;
					case "bucket": %this.setHeadUp(%bool); break;
					case "cape": %this.setHeadUp(%bool); break;
					case "pack": %this.setHeadUp(%bool); break;
					case "quiver": %this.setHeadUp(%bool); break;
					case "tank": %this.setHeadUp(%bool); break;
				}
			}
		}
		for(%i = 0; %i < getWordCount(%node); %i++)
		{
			%n = getWord(%node, %i);
			switch(%action)
			{
				case 0: %this.setNodeColor(%n, %color);
				case 1: %this.hidenode(%n);
				case 2: %this.unhidenode(%n); %this.setNodeColor(%n, %color);
				case 3: %this.setDecalName(%n);
				case 4: %this.setFaceName(%n);
			}
		}
	}
}

function AIPlayer::FireWeapon(%this, %int)
{
	if(%this.getClassName() $= "AIplayer")
	{
		%this.setImageTrigger(0, 1);
		%this.schedule(%int, setImageTrigger, 0, 0);
	}
}
function FxDTSbrick::BotFireWeapon(%this, %int)
{
	if(isObject(%obj = %this.hBot))
	{
		if(%obj.getClassName() $= "AIplayer")
		{
			%obj.BotFireWeapon(%int);
		}
	}
}

function jumpToZ(%obj, %z)
{
	if(isObject(%obj) && strLen(getWord(%dest = %obj.spawnPosition, 2)) > 0)
	{
		if(%obj.getClassName() $= "AIplayer")
		{
			%pos = %obj.getPosition();
			%obj.setMoveX(0);
			if(getRandom() > 0.5)
			{
				%obj.setMoveX(getRandom(-1,1));
			}
			if(getWord(%pos, 2) < %z)
			{
				%obj.botjump();
				%obj.jumpsched = %obj.schedule(1000, jumpToZ, %z);
			}
		}
	}
}